/// <reference types="node" />
import { LogAbstract, FSM } from '@dra2020/baseclient';
export interface Environment {
    log: LogAbstract.ILog;
    fsmManager: FSM.FsmManager;
}
export declare class FsmUnlink extends FSM.Fsm {
    path: string;
    err: any;
    constructor(env: Environment, path: string);
    tick(): void;
}
export declare class FsmMkdir extends FSM.Fsm {
    dir: string;
    bAllowExist: boolean;
    err: any;
    constructor(env: Environment, dir: string, bAllowExist?: boolean);
    tick(): void;
}
export declare class FsmRmdir extends FSM.Fsm {
    dir: string;
    err: any;
    constructor(env: Environment, dir: string);
    tick(): void;
}
export declare class FsmLs extends FSM.Fsm {
    dir: string;
    err: any;
    entries: string[];
    constructor(env: Environment, dir: string);
    tick(): void;
}
export declare class FsmReadFile extends FSM.Fsm {
    path: string;
    result: string;
    err: any;
    constructor(env: Environment, path: string);
    tick(): void;
}
export declare class FsmWriteFile extends FSM.Fsm {
    path: string;
    contents: string | Buffer;
    err: any;
    constructor(env: Environment, path: string, contents: string | Buffer);
    tick(): void;
}
