import { Context, LogAbstract, FSM } from '@dra2020/baseclient';
import * as Storage from '../storage/all';
import { LogKey } from './logkey';
interface Environment {
    context: Context.IContext;
    log: LogAbstract.ILog;
    fsmManager: FSM.FsmManager;
    storageManager: Storage.StorageManager;
}
export interface Options {
    dateFilter?: string;
}
export declare class LogBlob extends Storage.StorageBlob {
    key: LogKey;
    options: Options;
    constructor(env: Environment, params: Storage.BlobParams);
    get env(): Environment;
    get result(): string;
    static createForDownload(env: Environment, id: string): LogBlob;
    static createForUpload(env: Environment, id: string, data: string): LogBlob;
    static createForDelete(env: Environment, id: string): LogBlob;
    static createForLs(env: Environment, options?: Options): LogBlob;
    filter(s: string): boolean;
    asString(): string;
}
export {};
