import { Context, LogAbstract, FSM } from '@dra2020/baseclient';
import * as Storage from '../storage/all';
import { LogBlob } from './logblob';
interface Environment {
    context: Context.IContext;
    log: LogAbstract.ILog;
    fsmManager: FSM.FsmManager;
    storageManager: Storage.StorageManager;
}
export declare class FsmCompact extends FSM.Fsm {
    blobLs: LogBlob;
    clusters: {
        [key: string]: string[];
    };
    constructor(env: Environment);
    get env(): Environment;
    gatherLogList(logs: string[]): void;
    tick(): void;
}
declare class Permuter {
    tag: string;
    entries: {
        [key: string]: {
            key: string;
            to: string;
            from: string;
        };
    };
    mapper: {
        [from: string]: string;
    };
    length: number;
    constructor(tag: string);
    reset(): void;
    add(fields: string[]): void;
    map(from: string): string;
    asCSV(): string[];
}
export declare class FsmCompactOne extends FSM.Fsm {
    key: string;
    cluster: string[];
    blobs: LogBlob[];
    csv: string[];
    schemas: Permuter;
    templates: Permuter;
    constructor(env: Environment, key: string, cluster: string[]);
    get env(): Environment;
    loadBlobs(): void;
    saveBlobs(): void;
    deleteBlobs(): void;
    tick(): void;
}
export {};
