export interface OrderedListEntry<T> {
    prev: OrderedListEntry<T>;
    next: OrderedListEntry<T>;
    value: T;
}
export declare type OrderedListIndex<T> = {
    [key: string]: OrderedListEntry<T>;
};
export declare class OrderedList<T> {
    head: OrderedListEntry<T>;
    tail: OrderedListEntry<T>;
    index: OrderedListIndex<T>;
    constructor();
    isempty(): boolean;
    clear(): void;
    insert(key: string, value: T): string;
    remove(key: string): string;
    forEach(cb: (value: T) => boolean): void;
}
